package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.HexDeserializer;
import io.accumulatenetwork.sdk.support.serializers.HexSerializer;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("KeySpec")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class KeySpec implements Marshallable {
	private byte[] publicKeyHash;
	private long lastUsedOn;
	private Url delegate;

    //
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getPublicKeyHash() {
	    return publicKeyHash;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setPublicKeyHash(final byte[] value) {
	    this.publicKeyHash = value;
	}

	public KeySpec publicKeyHash(final byte[] value) {
	    setPublicKeyHash(value);
	    return this;
	}
	public KeySpec publicKeyHash(final String value) {
		try {
			setPublicKeyHash(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
	public long getLastUsedOn() {
	    return lastUsedOn;
	}
	public void setLastUsedOn(final long value) {
	    this.lastUsedOn = value;
	}

	public KeySpec lastUsedOn(final long value) {
	    setLastUsedOn(value);
	    return this;
	}
	public Url getDelegate() {
	    return delegate;
	}
	public void setDelegate(final Url value) {
	    this.delegate = value;
	}

	public KeySpec delegate(final Url value) {
	    setDelegate(value);
	    return this;
	}
	public KeySpec delegate(final String value) {
	    setDelegate(Url.toAccURL(value));
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.publicKeyHash == null || this.publicKeyHash.length == 0)) {
            marshaller.writeBytes(1, this.publicKeyHash);
        }
        if (!(this.lastUsedOn == 0)) {
            marshaller.writeUint(2, this.lastUsedOn);
        }
        if (!(this.delegate == null)) {
            marshaller.writeUrl(3, this.delegate);
        }
        return marshaller.array();
    }
}
